*** a/contrib/postgres_fdw/postgres_fdw.c
--- b/contrib/postgres_fdw/postgres_fdw.c
***************
*** 28,34 ****
  #include "optimizer/pathnode.h"
  #include "optimizer/paths.h"
  #include "optimizer/planmain.h"
- #include "optimizer/prep.h"
  #include "optimizer/restrictinfo.h"
  #include "optimizer/var.h"
  #include "parser/parsetree.h"
--- 28,33 ----
***************
*** 68,74 **** enum FdwScanPrivateIndex
  	/* SQL statement to execute remotely (as a String node) */
  	FdwScanPrivateSelectSql,
  	/* Integer list of attribute numbers retrieved by the SELECT */
! 	FdwScanPrivateRetrievedAttrs
  };
  
  /*
--- 67,79 ----
  	/* SQL statement to execute remotely (as a String node) */
  	FdwScanPrivateSelectSql,
  	/* Integer list of attribute numbers retrieved by the SELECT */
! 	FdwScanPrivateRetrievedAttrs,
! 	/* Integer value of server for the scan */
! 	FdwScanPrivateServerOid,
! 	/* Integer value of user mapping for the scan */
! 	FdwScanPrivateUserMappingOid,
! 	/* Names of relation scanned, added when the scan is join */
! 	FdwScanPrivateRelations,
  };
  
  /*
***************
*** 98,104 **** enum FdwModifyPrivateIndex
   */
  typedef struct PgFdwScanState
  {
! 	Relation	rel;			/* relcache entry for the foreign table */
  	AttInMetadata *attinmeta;	/* attribute datatype conversion metadata */
  
  	/* extracted fdw_private data */
--- 103,110 ----
   */
  typedef struct PgFdwScanState
  {
! 	const char *relname;		/* name of relation being scanned */
! 	TupleDesc	tupdesc;		/* tuple descriptor of the scan */
  	AttInMetadata *attinmeta;	/* attribute datatype conversion metadata */
  
  	/* extracted fdw_private data */
***************
*** 164,169 **** typedef struct PgFdwAnalyzeState
--- 170,177 ----
  	AttInMetadata *attinmeta;	/* attribute datatype conversion metadata */
  	List	   *retrieved_attrs;	/* attr numbers retrieved by query */
  
+ 	char	   *query;			/* text of SELECT command */
+ 
  	/* collected sample rows */
  	HeapTuple  *rows;			/* array of size targrows */
  	int			targrows;		/* target # of sample rows */
***************
*** 184,190 **** typedef struct PgFdwAnalyzeState
   */
  typedef struct ConversionLocation
  {
! 	Relation	rel;			/* foreign table's relcache entry */
  	AttrNumber	cur_attno;		/* attribute number being processed, or 0 */
  } ConversionLocation;
  
--- 192,201 ----
   */
  typedef struct ConversionLocation
  {
! 	const char *relname;		/* name of relation being processed, or NULL for
! 								   a foreign join */
! 	const char *query;			/* query being processed */
! 	TupleDesc	tupdesc;		/* tuple descriptor for attribute names */
  	AttrNumber	cur_attno;		/* attribute number being processed, or 0 */
  } ConversionLocation;
  
***************
*** 247,252 **** static TupleTableSlot *postgresExecForeignDelete(EState *estate,
--- 258,265 ----
  static void postgresEndForeignModify(EState *estate,
  						 ResultRelInfo *resultRelInfo);
  static int	postgresIsForeignRelUpdatable(Relation rel);
+ static bool postgresRecheckForeignScan(ForeignScanState *node,
+ 									   TupleTableSlot *slot);
  static void postgresExplainForeignScan(ForeignScanState *node,
  						   ExplainState *es);
  static void postgresExplainForeignModify(ModifyTableState *mtstate,
***************
*** 259,264 **** static bool postgresAnalyzeForeignTable(Relation relation,
--- 272,283 ----
  							BlockNumber *totalpages);
  static List *postgresImportForeignSchema(ImportForeignSchemaStmt *stmt,
  							Oid serverOid);
+ static void postgresGetForeignJoinPaths(PlannerInfo *root,
+ 										RelOptInfo *joinrel,
+ 										RelOptInfo *outerrel,
+ 										RelOptInfo *innerrel,
+ 										JoinType jointype,
+ 										JoinPathExtraData *extra);
  
  /*
   * Helper functions
***************
*** 295,306 **** static void analyze_row_processor(PGresult *res, int row,
  					  PgFdwAnalyzeState *astate);
  static HeapTuple make_tuple_from_result_row(PGresult *res,
  						   int row,
! 						   Relation rel,
  						   AttInMetadata *attinmeta,
  						   List *retrieved_attrs,
  						   MemoryContext temp_context);
  static void conversion_error_callback(void *arg);
  
  
  /*
   * Foreign-data wrapper handler function: return a struct with pointers
--- 314,354 ----
  					  PgFdwAnalyzeState *astate);
  static HeapTuple make_tuple_from_result_row(PGresult *res,
  						   int row,
! 						   const char *relname,
! 						   const char *query,
! 						   TupleDesc tupdesc,
  						   AttInMetadata *attinmeta,
  						   List *retrieved_attrs,
  						   MemoryContext temp_context);
  static void conversion_error_callback(void *arg);
+ static Path *get_unsorted_unparameterized_path(List *paths);
+ 
+ /*
+  * Describe Bitmapset as comma-separated integer list.
+  * For debug purpose.
+  * XXX Can this become a member of bitmapset.c?
+  */
+ static char *
+ bms_to_str(Bitmapset *bmp)
+ {
+ 	StringInfoData buf;
+ 	bool		first = true;
+ 	int			x;
  
+ 	initStringInfo(&buf);
+ 
+ 	x = -1;
+ 	while ((x = bms_next_member(bmp, x)) >= 0)
+ 	{
+ 		if (!first)
+ 			appendStringInfoString(&buf, ", ");
+ 		appendStringInfo(&buf, "%d", x);
+ 
+ 		first = false;
+ 	}
+ 
+ 	return buf.data;
+ }
  
  /*
   * Foreign-data wrapper handler function: return a struct with pointers
***************
*** 330,335 **** postgres_fdw_handler(PG_FUNCTION_ARGS)
--- 378,386 ----
  	routine->EndForeignModify = postgresEndForeignModify;
  	routine->IsForeignRelUpdatable = postgresIsForeignRelUpdatable;
  
+ 	/* Functions for SELECT FOR UPDATE/SHARE row locking */
+ 	routine->RecheckForeignScan = postgresRecheckForeignScan;
+ 
  	/* Support functions for EXPLAIN */
  	routine->ExplainForeignScan = postgresExplainForeignScan;
  	routine->ExplainForeignModify = postgresExplainForeignModify;
***************
*** 340,345 **** postgres_fdw_handler(PG_FUNCTION_ARGS)
--- 391,399 ----
  	/* Support functions for IMPORT FOREIGN SCHEMA */
  	routine->ImportForeignSchema = postgresImportForeignSchema;
  
+ 	/* Support functions for join push-down */
+ 	routine->GetForeignJoinPaths = postgresGetForeignJoinPaths;
+ 
  	PG_RETURN_POINTER(routine);
  }
  
***************
*** 365,373 **** postgresGetForeignRelSize(PlannerInfo *root,
--- 419,431 ----
  	fpinfo = (PgFdwRelationInfo *) palloc0(sizeof(PgFdwRelationInfo));
  	baserel->fdw_private = (void *) fpinfo;
  
+ 	/* This scan can be pushed down to the remote. */
+ 	fpinfo->pushdown_safe = true;
+ 
  	/* Look up foreign-table catalog info. */
  	fpinfo->table = GetForeignTable(foreigntableid);
  	fpinfo->server = GetForeignServer(fpinfo->table->serverid);
+ 	fpinfo->umid = baserel->umid;
  
  	/*
  	 * Extract user-settable option values.  Note that per-table setting of
***************
*** 404,425 **** postgresGetForeignRelSize(PlannerInfo *root,
  	}
  
  	/*
- 	 * If the table or the server is configured to use remote estimates,
- 	 * identify which user to do remote access as during planning.  This
- 	 * should match what ExecCheckRTEPerms() does.  If we fail due to lack of
- 	 * permissions, the query would have failed at runtime anyway.
- 	 */
- 	if (fpinfo->use_remote_estimate)
- 	{
- 		RangeTblEntry *rte = planner_rt_fetch(baserel->relid, root);
- 		Oid			userid = rte->checkAsUser ? rte->checkAsUser : GetUserId();
- 
- 		fpinfo->user = GetUserMapping(userid, fpinfo->server->serverid);
- 	}
- 	else
- 		fpinfo->user = NULL;
- 
- 	/*
  	 * Identify which baserestrictinfo clauses can be sent to the remote
  	 * server and which can't.
  	 */
--- 462,467 ----
***************
*** 788,793 **** postgresGetForeignPlan(PlannerInfo *root,
--- 830,837 ----
  	List	   *retrieved_attrs;
  	StringInfoData sql;
  	ListCell   *lc;
+ 	List	   *fdw_scan_tlist = NIL;
+ 	StringInfoData relations;
  
  	/*
  	 * Separate the scan_clauses into those that can be executed remotely and
***************
*** 834,910 **** postgresGetForeignPlan(PlannerInfo *root,
  			local_exprs = lappend(local_exprs, rinfo->clause);
  	}
  
  	/*
  	 * Build the query string to be sent for execution, and identify
  	 * expressions to be sent as parameters.
  	 */
  	initStringInfo(&sql);
! 	deparseSelectSql(&sql, root, baserel, fpinfo->attrs_used,
! 					 &retrieved_attrs);
! 	if (remote_conds)
! 		appendWhereClause(&sql, root, baserel, remote_conds,
! 						  true, &params_list);
! 
! 	/* Add ORDER BY clause if we found any useful pathkeys */
! 	if (best_path->path.pathkeys)
! 		appendOrderByClause(&sql, root, baserel, best_path->path.pathkeys);
! 
! 	/*
! 	 * Add FOR UPDATE/SHARE if appropriate.  We apply locking during the
! 	 * initial row fetch, rather than later on as is done for local tables.
! 	 * The extra roundtrips involved in trying to duplicate the local
! 	 * semantics exactly don't seem worthwhile (see also comments for
! 	 * RowMarkType).
! 	 *
! 	 * Note: because we actually run the query as a cursor, this assumes that
! 	 * DECLARE CURSOR ... FOR UPDATE is supported, which it isn't before 8.3.
! 	 */
! 	if (baserel->relid == root->parse->resultRelation &&
! 		(root->parse->commandType == CMD_UPDATE ||
! 		 root->parse->commandType == CMD_DELETE))
! 	{
! 		/* Relation is UPDATE/DELETE target, so use FOR UPDATE */
! 		appendStringInfoString(&sql, " FOR UPDATE");
! 	}
! 	else
! 	{
! 		PlanRowMark *rc = get_plan_rowmark(root->rowMarks, baserel->relid);
! 
! 		if (rc)
! 		{
! 			/*
! 			 * Relation is specified as a FOR UPDATE/SHARE target, so handle
! 			 * that.  (But we could also see LCS_NONE, meaning this isn't a
! 			 * target relation after all.)
! 			 *
! 			 * For now, just ignore any [NO] KEY specification, since (a) it's
! 			 * not clear what that means for a remote table that we don't have
! 			 * complete information about, and (b) it wouldn't work anyway on
! 			 * older remote servers.  Likewise, we don't worry about NOWAIT.
! 			 */
! 			switch (rc->strength)
! 			{
! 				case LCS_NONE:
! 					/* No locking needed */
! 					break;
! 				case LCS_FORKEYSHARE:
! 				case LCS_FORSHARE:
! 					appendStringInfoString(&sql, " FOR SHARE");
! 					break;
! 				case LCS_FORNOKEYUPDATE:
! 				case LCS_FORUPDATE:
! 					appendStringInfoString(&sql, " FOR UPDATE");
! 					break;
! 			}
! 		}
! 	}
  
  	/*
  	 * Build the fdw_private list that will be available to the executor.
  	 * Items in the list must match enum FdwScanPrivateIndex, above.
  	 */
! 	fdw_private = list_make2(makeString(sql.data),
! 							 retrieved_attrs);
  
  	/*
  	 * Create the ForeignScan node from target list, filtering expressions,
--- 878,921 ----
  			local_exprs = lappend(local_exprs, rinfo->clause);
  	}
  
+ 	if (scan_relid == 0)
+ 	{
+ 		Assert(scan_clauses == NIL);
+ 		Assert(remote_conds == NIL);
+ 		Assert(remote_exprs == NIL);
+ 	}
+ 
  	/*
  	 * Build the query string to be sent for execution, and identify
  	 * expressions to be sent as parameters.
  	 */
  	initStringInfo(&sql);
! 	if (baserel->reloptkind == RELOPT_JOINREL)
! 		initStringInfo(&relations);
! 	deparseSelectSql(&sql, root, baserel, fpinfo->attrs_used, remote_conds,
! 					 best_path->path.pathkeys,
! 					 &params_list, &fdw_scan_tlist, &retrieved_attrs,
! 					 baserel->reloptkind == RELOPT_JOINREL ? &relations : NULL,
! 					 false);
  
  	/*
  	 * Build the fdw_private list that will be available to the executor.
  	 * Items in the list must match enum FdwScanPrivateIndex, above.
  	 */
! 	fdw_private = list_make4(makeString(sql.data),
! 							 retrieved_attrs,
! 							 makeInteger(fpinfo->server->serverid),
! 							 makeInteger(fpinfo->umid));
! 	if (baserel->reloptkind == RELOPT_JOINREL)
! 		fdw_private = lappend(fdw_private, makeString(relations.data));
! 
! 	/* Adjust outer_plan */
! 	if (scan_relid == 0)
! 	{
! 		Assert(outer_plan != NULL);
! 		outer_plan->targetlist = fdw_scan_tlist;
! 		outer_plan->qual = fpinfo->otherclauses;
! 	}
  
  	/*
  	 * Create the ForeignScan node from target list, filtering expressions,
***************
*** 919,925 **** postgresGetForeignPlan(PlannerInfo *root,
  							scan_relid,
  							params_list,
  							fdw_private,
! 							NIL,	/* no custom tlist */
  							remote_exprs,
  							outer_plan);
  }
--- 930,936 ----
  							scan_relid,
  							params_list,
  							fdw_private,
! 							fdw_scan_tlist,
  							remote_exprs,
  							outer_plan);
  }
***************
*** 934,942 **** postgresBeginForeignScan(ForeignScanState *node, int eflags)
  	ForeignScan *fsplan = (ForeignScan *) node->ss.ps.plan;
  	EState	   *estate = node->ss.ps.state;
  	PgFdwScanState *fsstate;
! 	RangeTblEntry *rte;
! 	Oid			userid;
! 	ForeignTable *table;
  	ForeignServer *server;
  	UserMapping *user;
  	int			numParams;
--- 945,952 ----
  	ForeignScan *fsplan = (ForeignScan *) node->ss.ps.plan;
  	EState	   *estate = node->ss.ps.state;
  	PgFdwScanState *fsstate;
! 	Oid			serverid;
! 	Oid			umid;
  	ForeignServer *server;
  	UserMapping *user;
  	int			numParams;
***************
*** 956,977 **** postgresBeginForeignScan(ForeignScanState *node, int eflags)
  	node->fdw_state = (void *) fsstate;
  
  	/*
- 	 * Identify which user to do the remote access as.  This should match what
- 	 * ExecCheckRTEPerms() does.
- 	 */
- 	rte = rt_fetch(fsplan->scan.scanrelid, estate->es_range_table);
- 	userid = rte->checkAsUser ? rte->checkAsUser : GetUserId();
- 
- 	/* Get info about foreign table. */
- 	fsstate->rel = node->ss.ss_currentRelation;
- 	table = GetForeignTable(RelationGetRelid(fsstate->rel));
- 	server = GetForeignServer(table->serverid);
- 	user = GetUserMapping(userid, server->serverid);
- 
- 	/*
  	 * Get connection to the foreign server.  Connection manager will
  	 * establish new connection if necessary.
  	 */
  	fsstate->conn = GetConnection(server, user, false);
  
  	/* Assign a unique ID for my cursor */
--- 966,978 ----
  	node->fdw_state = (void *) fsstate;
  
  	/*
  	 * Get connection to the foreign server.  Connection manager will
  	 * establish new connection if necessary.
  	 */
+ 	serverid = intVal(list_nth(fsplan->fdw_private, FdwScanPrivateServerOid));
+ 	umid = intVal(list_nth(fsplan->fdw_private, FdwScanPrivateUserMappingOid));
+ 	server = GetForeignServer(serverid);
+ 	user = GetUserMappingById(umid);
  	fsstate->conn = GetConnection(server, user, false);
  
  	/* Assign a unique ID for my cursor */
***************
*** 996,1003 **** postgresBeginForeignScan(ForeignScanState *node, int eflags)
  											  ALLOCSET_SMALL_INITSIZE,
  											  ALLOCSET_SMALL_MAXSIZE);
  
! 	/* Get info we'll need for input data conversion. */
! 	fsstate->attinmeta = TupleDescGetAttInMetadata(RelationGetDescr(fsstate->rel));
  
  	/* Prepare for output conversion of parameters used in remote query. */
  	numParams = list_length(fsplan->fdw_exprs);
--- 997,1014 ----
  											  ALLOCSET_SMALL_INITSIZE,
  											  ALLOCSET_SMALL_MAXSIZE);
  
! 	/* Get info we'll need for input data conversion and error report. */
! 	if (fsplan->scan.scanrelid > 0)
! 	{
! 		fsstate->relname = RelationGetRelationName(node->ss.ss_currentRelation);
! 		fsstate->tupdesc = RelationGetDescr(node->ss.ss_currentRelation);
! 	}
! 	else
! 	{
! 		fsstate->relname = NULL;
! 		fsstate->tupdesc = node->ss.ss_ScanTupleSlot->tts_tupleDescriptor;
! 	}
! 	fsstate->attinmeta = TupleDescGetAttInMetadata(fsstate->tupdesc);
  
  	/* Prepare for output conversion of parameters used in remote query. */
  	numParams = list_length(fsplan->fdw_exprs);
***************
*** 1718,1723 **** postgresIsForeignRelUpdatable(Relation rel)
--- 1729,1761 ----
  }
  
  /*
+  * postgresRecheckForeignScan
+  *		Execute a local join execution plan for a foreign join
+  */
+ static bool
+ postgresRecheckForeignScan(ForeignScanState *node, TupleTableSlot *slot)
+ {
+ 	Index		scanrelid = ((Scan *) node->ss.ps.plan)->scanrelid;
+ 	PlanState  *outerPlan = outerPlanState(node);
+ 	TupleTableSlot *result;
+ 
+ 	if (scanrelid > 0)
+ 		return true;
+ 
+ 	Assert(outerPlan != NULL);
+ 
+ 	/* Execute a local join execution plan */
+ 	result = ExecProcNode(outerPlan);
+ 	if (TupIsNull(result))
+ 		return false;
+ 
+ 	/* Store result in the given slot */
+ 	ExecCopySlot(slot, result);
+ 
+ 	return true;
+ }
+ 
+ /*
   * postgresExplainForeignScan
   *		Produce extra output for EXPLAIN of a ForeignScan on a foreign table
   */
***************
*** 1726,1735 **** postgresExplainForeignScan(ForeignScanState *node, ExplainState *es)
  {
  	List	   *fdw_private;
  	char	   *sql;
  
  	if (es->verbose)
  	{
- 		fdw_private = ((ForeignScan *) node->ss.ps.plan)->fdw_private;
  		sql = strVal(list_nth(fdw_private, FdwScanPrivateSelectSql));
  		ExplainPropertyText("Remote SQL", sql, es);
  	}
--- 1764,1788 ----
  {
  	List	   *fdw_private;
  	char	   *sql;
+ 	char	   *relations;
+ 
+ 	fdw_private = ((ForeignScan *) node->ss.ps.plan)->fdw_private;
+ 
+ 	/*
+ 	 * Add names of relation handled by the foreign scan when the scan is a
+ 	 * join
+ 	 */
+ 	if (list_length(fdw_private) > FdwScanPrivateRelations)
+ 	{
+ 		relations = strVal(list_nth(fdw_private, FdwScanPrivateRelations));
+ 		ExplainPropertyText("Relations", relations, es);
+ 	}
  
+ 	/*
+ 	 * Add remote query, when VERBOSE option is specified.
+ 	 */
  	if (es->verbose)
  	{
  		sql = strVal(list_nth(fdw_private, FdwScanPrivateSelectSql));
  		ExplainPropertyText("Remote SQL", sql, es);
  	}
***************
*** 1789,1798 **** estimate_path_cost_size(PlannerInfo *root,
--- 1842,1853 ----
  	 */
  	if (fpinfo->use_remote_estimate)
  	{
+ 		List	   *remote_conds;
  		List	   *remote_join_conds;
  		List	   *local_join_conds;
  		StringInfoData sql;
  		List	   *retrieved_attrs;
+ 		UserMapping *user;
  		PGconn	   *conn;
  		Selectivity local_sel;
  		QualCost	local_cost;
***************
*** 1804,1830 **** estimate_path_cost_size(PlannerInfo *root,
  		classifyConditions(root, baserel, join_conds,
  						   &remote_join_conds, &local_join_conds);
  
  		/*
  		 * Construct EXPLAIN query including the desired SELECT, FROM, and
  		 * WHERE clauses.  Params and other-relation Vars are replaced by
  		 * dummy values.
  		 */
  		initStringInfo(&sql);
  		appendStringInfoString(&sql, "EXPLAIN ");
! 		deparseSelectSql(&sql, root, baserel, fpinfo->attrs_used,
! 						 &retrieved_attrs);
! 		if (fpinfo->remote_conds)
! 			appendWhereClause(&sql, root, baserel, fpinfo->remote_conds,
! 							  true, NULL);
! 		if (remote_join_conds)
! 			appendWhereClause(&sql, root, baserel, remote_join_conds,
! 							  (fpinfo->remote_conds == NIL), NULL);
! 
! 		if (pathkeys)
! 			appendOrderByClause(&sql, root, baserel, pathkeys);
  
  		/* Get the remote estimate */
! 		conn = GetConnection(fpinfo->server, fpinfo->user, false);
  		get_remote_estimate(sql.data, conn, &rows, &width,
  							&startup_cost, &total_cost);
  		ReleaseConnection(conn);
--- 1859,1882 ----
  		classifyConditions(root, baserel, join_conds,
  						   &remote_join_conds, &local_join_conds);
  
+ 		remote_conds = copyObject(fpinfo->remote_conds);
+ 		remote_conds = list_concat(remote_conds, remote_join_conds);
+ 
  		/*
  		 * Construct EXPLAIN query including the desired SELECT, FROM, and
  		 * WHERE clauses.  Params and other-relation Vars are replaced by
  		 * dummy values.
+ 		 * Here we waste params_list and fdw_scan_tlist because they are
+ 		 * unnecessary for EXPLAIN.
  		 */
  		initStringInfo(&sql);
  		appendStringInfoString(&sql, "EXPLAIN ");
! 		deparseSelectSql(&sql, root, baserel, fpinfo->attrs_used, remote_conds,
! 						 pathkeys, NULL, NULL, &retrieved_attrs, NULL, false);
  
  		/* Get the remote estimate */
! 		user = GetUserMappingById(fpinfo->umid);
! 		conn = GetConnection(fpinfo->server, user, false);
  		get_remote_estimate(sql.data, conn, &rows, &width,
  							&startup_cost, &total_cost);
  		ReleaseConnection(conn);
***************
*** 2136,2142 **** fetch_more_data(ForeignScanState *node)
  		{
  			fsstate->tuples[i] =
  				make_tuple_from_result_row(res, i,
! 										   fsstate->rel,
  										   fsstate->attinmeta,
  										   fsstate->retrieved_attrs,
  										   fsstate->temp_cxt);
--- 2188,2196 ----
  		{
  			fsstate->tuples[i] =
  				make_tuple_from_result_row(res, i,
! 										   fsstate->relname,
! 										   fsstate->query,
! 										   fsstate->tupdesc,
  										   fsstate->attinmeta,
  										   fsstate->retrieved_attrs,
  										   fsstate->temp_cxt);
***************
*** 2354,2360 **** store_returning_result(PgFdwModifyState *fmstate,
  		HeapTuple	newtup;
  
  		newtup = make_tuple_from_result_row(res, 0,
! 											fmstate->rel,
  											fmstate->attinmeta,
  											fmstate->retrieved_attrs,
  											fmstate->temp_cxt);
--- 2408,2416 ----
  		HeapTuple	newtup;
  
  		newtup = make_tuple_from_result_row(res, 0,
! 										RelationGetRelationName(fmstate->rel),
! 											fmstate->query,
! 											RelationGetDescr(fmstate->rel),
  											fmstate->attinmeta,
  											fmstate->retrieved_attrs,
  											fmstate->temp_cxt);
***************
*** 2504,2509 **** postgresAcquireSampleRowsFunc(Relation relation, int elevel,
--- 2560,2566 ----
  	initStringInfo(&sql);
  	appendStringInfo(&sql, "DECLARE c%u CURSOR FOR ", cursor_number);
  	deparseAnalyzeSql(&sql, relation, &astate.retrieved_attrs);
+ 	astate.query = sql.data;
  
  	/* In what follows, do not risk leaking any PGresults. */
  	PG_TRY();
***************
*** 2645,2651 **** analyze_row_processor(PGresult *res, int row, PgFdwAnalyzeState *astate)
  		oldcontext = MemoryContextSwitchTo(astate->anl_cxt);
  
  		astate->rows[pos] = make_tuple_from_result_row(res, row,
! 													   astate->rel,
  													   astate->attinmeta,
  													 astate->retrieved_attrs,
  													   astate->temp_cxt);
--- 2702,2710 ----
  		oldcontext = MemoryContextSwitchTo(astate->anl_cxt);
  
  		astate->rows[pos] = make_tuple_from_result_row(res, row,
! 										   RelationGetRelationName(astate->rel),
! 													   astate->query,
! 											   RelationGetDescr(astate->rel),
  													   astate->attinmeta,
  													 astate->retrieved_attrs,
  													   astate->temp_cxt);
